package com.palserv.component;

/**
 * A class should use this interface if it intends
 * to use a PalCal object.
 * The DateBox class is an example of a class which
 * implements CallPalCal.
 */
public interface CallPalCal {

/**
 * The PalCal object calls this method during the
 * PalCal constructor to obtain the date to display.
 * @return the date for PalCal to display.
 */
	String getUseDate();

/**
 * The PalCal object calls this method when the user
 * selects a date.	This is how PalCal "returns" the
 * user selection to the class which implements CallPalCal.
 * It is in this method that the CallPalCal "class" should
 * invoke the "dispose" method on the PalCal object.
 * @param s the date "returned" by PalCal
 */
	void setResponse(String s);

/**
 * The PalCal object calls this method during the
 * PalCal constructor to obtain a DateFormatter object.
 * The PalCal object doesn't change the DateFormatter
 * object in any way, thus it makes sense for the CallPalCal
 * "class" to share its DateFormatter object with PalCal.
 * @return sets date format
 */
	DateFormatter getDF();
}
