import java.util.*;

class PalTest01 {
	public static void main(String[] args) {
		PalTest01 pt = new PalTest01();
//		  for (int i = 1; i < 5; i ++) {
			for (int j = 5; j < 8; j ++) {
				pt.test2(j, 5, 2001);
			}
//		  }
	}

	void test2(int m, int d, int yr) {
		Calendar calendar = new GregorianCalendar(yr, m, d);
		int dow = calendar.get(Calendar.DAY_OF_WEEK);
		int dom = calendar.get(Calendar.DAY_OF_MONTH);
		int off = (7 - ((dom + 7 - dow) % 7)) % 7;
		// day of week of first of month
		int dowofom = off + 1;
		// number of days in month
		int ndim = getDim(m, yr);
// spt("there are "+ndim+ " days in the month");
		// number of days in first week
		int tndfw = 7 - off;
// spt("there are "+tndfw+ " days in the first week");
		// number of days minus first week
		int tndmfw = ndim - tndfw;
// spt("there are "+tndmfw+ " days left in month (after the first week)");
		// number of whole weeks past first (incomplete) week
		int tnwwpfw = tndmfw / 7;
// spt("there are "+tnwwpfw+ " whole weeks past first week");
		// number of days left over
		int tndlo = (tndmfw - (tnwwpfw * 7)) % 7;
// spt("there are "+tndlo+ " days left over");
		// number of weeks to show
		int nws = tnwwpfw + (tndlo == 0?0:1) + (tndfw == 0?0:1);
// spt("there are "+nws+ " weeks to show");
//		  spt("offset="+off+"; mon="+m+"; day="+d+"; dow="+dow+"; dom="+dom+"; dowofom="+dowofom);
		spt(getMonName(m)+" "+yr);
		spt("S  M  T  W  T  F  S");
		int day = 1;
		StringBuffer sb = new StringBuffer();
		if	(off > 0) {
			int mm = m;
			int yrr = yr;
			mm --;
			if (mm < 0) {
				mm = 12;
				yrr --;
			}
			int ndlm = getDim(mm, yrr);
			int fd = ndlm - off + 1;
			for (int i = 0; i < off; i ++) {
				sb.append(numForm(fd,2)+" ");
				fd ++;
			}
			for (int i = 0; i < (7 - off); i ++) {
				sb.append(numForm(day,2)+" ");
				day ++;
			}
		} else {
			tnwwpfw ++;
		}
		spt(sb.toString());
		sb.delete(0,sb.length());
		for (int i = 0; i < tnwwpfw; i ++) {
			for (int j = 0; j < 7; j ++) {
				sb.append(numForm(day,2) + " ");
				day ++;
			}
			spt(sb.toString());
			sb.delete(0,sb.length());
		}
		if (tndlo > 0) {
			for (int i = 0; i < tndlo; i ++) {
				sb.append(numForm(day,2) + " ");
				day ++;
			}
			for (int i = 0; i < (7 - tndlo); i ++) {
				sb.append(numForm(i + 1,2) + " ");
			}
			spt(sb.toString());
			sb.delete(0,sb.length());
		}
	}

/**
 * return a string of "n" of length "l"
 * right justified, padded to the left with zeros
 */
	public static String numForm(int n, int l) {
		Integer i = new Integer(n);
		String s = i.toString();
		String p = "0000000000000000000000" + s;
		int nl = p.length();
		int x = nl - l;
// spt("numForm: p = "+p+"; l = "+l+"; nl = "+nl+"; x = "+x);
		String r = p.substring(x, nl);
		return r;
	}

	void spt(String s) {
		System.out.println(s);
	}

	String getMonName(int m) {
		String[] mon = {"Jan", "Feb", "Mar", "Apr", "May", "Jun",
			"Jul", "Aug", "Sep", "Oct", "Nov", "Dec"};
		return mon[m];
	}

	int getDim(int mon, int yr) {
		int[] n = new int[] {31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31};
		int dim =  n[mon];
		if (mon == 1) { // Feb
			if (isLeap(yr)) {
				dim ++;
			}
		}
		return dim;
	}

	boolean isLeap(int yr) {
		boolean ret = false;
		if ((yr % 4) == 0) {	// divisible by 4
			if ((yr % 100) == 0) {	// divisible by 100
				if ((yr % 1000) == 0) {  // divisible by 1000
					// div by 4, and by 100, and by 1000
					return true;
/*
				} else {
					// div by 4, and by 100, but not by 1000
					return false;
*/
				}
			} else {
				// div by 4, not by 100
				return true;
			}
/*
		} else {
			// not div by 4
			return false;
*/
		}
		return ret;
	}

	void test1() {
		Calendar calendar = new GregorianCalendar(2001, 7, 26);
		int dow = calendar.get(Calendar.DAY_OF_WEEK);
		int dom = calendar.get(Calendar.DAY_OF_MONTH);
		int off = (dom + 7 - dow) % 7;
		System.out.println("offset: "+off);
		System.out.println("YEAR: " + calendar.get(Calendar.YEAR));
		System.out.println("MONTH: " + calendar.get(Calendar.MONTH));
		System.out.println("WEEK_OF_MONTH: " + calendar.get(Calendar.WEEK_OF_MONTH));
		System.out.println("DATE: " + calendar.get(Calendar.DATE));
		System.out.println("DAY_OF_MONTH: " + calendar.get(Calendar.DAY_OF_MONTH));
		System.out.println("DAY_OF_WEEK: " + calendar.get(Calendar.DAY_OF_WEEK));
	}

	void test() {
		// get the supported ids for GMT-08:00 (Pacific Standard Time)
		String[] ids = TimeZone.getAvailableIDs(-8 * 60 * 60 * 1000);
		// if no ids were returned, something is wrong. get out.
		if (ids.length == 0)
			System.exit(0);

		 // begin output
		System.out.println("Current Time");

		// create a Pacific Standard Time time zone
//		  SimpleTimeZone pdt = new SimpleTimeZone(-8 * 60 * 60 * 1000, ids[0]);
		SimpleTimeZone pdt = new SimpleTimeZone(-5 * 60 * 60 * 1000, ids[0]);

		// set up rules for daylight savings time
		pdt.setStartRule(Calendar.APRIL, 1, Calendar.SUNDAY, 2 * 60 * 60 * 1000);
		pdt.setEndRule(Calendar.OCTOBER, -1, Calendar.SUNDAY, 2 * 60 * 60 * 1000);

		// create a GregorianCalendar with the Pacific Daylight time zone
		// and the current date and time
		Calendar calendar = new GregorianCalendar(pdt);
		Date trialTime = new Date();
		calendar.setTime(trialTime);

		// print out a bunch of interesting things
		System.out.println("ERA: " + calendar.get(Calendar.ERA));
		System.out.println("YEAR: " + calendar.get(Calendar.YEAR));
		System.out.println("MONTH: " + calendar.get(Calendar.MONTH));
		System.out.println("WEEK_OF_YEAR: " + calendar.get(Calendar.WEEK_OF_YEAR));
		System.out.println("WEEK_OF_MONTH: " + calendar.get(Calendar.WEEK_OF_MONTH));
		System.out.println("DATE: " + calendar.get(Calendar.DATE));
		System.out.println("DAY_OF_MONTH: " + calendar.get(Calendar.DAY_OF_MONTH));
		System.out.println("DAY_OF_YEAR: " + calendar.get(Calendar.DAY_OF_YEAR));
		System.out.println("DAY_OF_WEEK: " + calendar.get(Calendar.DAY_OF_WEEK));
		System.out.println("DAY_OF_WEEK_IN_MONTH: "
						   + calendar.get(Calendar.DAY_OF_WEEK_IN_MONTH));
		System.out.println("AM_PM: " + calendar.get(Calendar.AM_PM));
		System.out.println("HOUR: " + calendar.get(Calendar.HOUR));
		System.out.println("HOUR_OF_DAY: " + calendar.get(Calendar.HOUR_OF_DAY));
		System.out.println("MINUTE: " + calendar.get(Calendar.MINUTE));
		System.out.println("SECOND: " + calendar.get(Calendar.SECOND));
		System.out.println("MILLISECOND: " + calendar.get(Calendar.MILLISECOND));
		System.out.println("ZONE_OFFSET: "
						   + (calendar.get(Calendar.ZONE_OFFSET)/(60*60*1000)));
		System.out.println("DST_OFFSET: "
						   + (calendar.get(Calendar.DST_OFFSET)/(60*60*1000)));

		System.out.println("Current Time, with hour reset to 3");
		calendar.clear(Calendar.HOUR_OF_DAY); // so doesn't override
		calendar.set(Calendar.HOUR, 3);
		System.out.println("ERA: " + calendar.get(Calendar.ERA));
		System.out.println("YEAR: " + calendar.get(Calendar.YEAR));
		System.out.println("MONTH: " + calendar.get(Calendar.MONTH));
		System.out.println("WEEK_OF_YEAR: " + calendar.get(Calendar.WEEK_OF_YEAR));
		System.out.println("WEEK_OF_MONTH: " + calendar.get(Calendar.WEEK_OF_MONTH));
		System.out.println("DATE: " + calendar.get(Calendar.DATE));
		System.out.println("DAY_OF_MONTH: " + calendar.get(Calendar.DAY_OF_MONTH));
		System.out.println("DAY_OF_YEAR: " + calendar.get(Calendar.DAY_OF_YEAR));
		System.out.println("DAY_OF_WEEK: " + calendar.get(Calendar.DAY_OF_WEEK));
		System.out.println("DAY_OF_WEEK_IN_MONTH: "
						   + calendar.get(Calendar.DAY_OF_WEEK_IN_MONTH));
		System.out.println("AM_PM: " + calendar.get(Calendar.AM_PM));
		System.out.println("HOUR: " + calendar.get(Calendar.HOUR));
		System.out.println("HOUR_OF_DAY: " + calendar.get(Calendar.HOUR_OF_DAY));
		System.out.println("MINUTE: " + calendar.get(Calendar.MINUTE));
		System.out.println("SECOND: " + calendar.get(Calendar.SECOND));
		System.out.println("MILLISECOND: " + calendar.get(Calendar.MILLISECOND));
		System.out.println("ZONE_OFFSET: "
			   + (calendar.get(Calendar.ZONE_OFFSET)/(60*60*1000))); // in hours
		System.out.println("DST_OFFSET: "
			   + (calendar.get(Calendar.DST_OFFSET)/(60*60*1000))); // in hours
	}
}
